# std::has_facet

From cppreference.com
< cpp‎ | locale

Defined in header `<locale>` |  |
template< class Facet > bool has_facet( const locale& loc ); |  |

Checks if the locale `loc` implements the facet `Facet`.

### Parameters

loc | - | the locale object to query

### Return value

Returns true if the facet `Facet` was installed in the locale `loc`, false otherwise.

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

### Example

Run this code

    #include <iostream>
    #include <locale>

    // minimal custom facet
    struct myfacet : public std::locale::facet {
        static std::locale::id id;
    };

    std::locale::id myfacet::id;

    int main()
    {
        // loc is a "C" locale with myfacet added
        std::locale loc(std::locale::classic(), new myfacet);
        std::cout << std::boolalpha
                  << "Can loc classify chars? "
                  << std::has_facet<std::ctype<char>>(loc) << '\n'
                  << "Can loc classify char32_t? "
                  << std::has_facet<std::ctype<char32_t>>(loc) << '\n'
                  << "Does loc implement myfacet? "
                  << std::has_facet<myfacet>(loc) << '\n';
    }

Output:

    Can loc classify chars? true
    Can loc classify char32_t? false
    Does loc implement myfacet? true

### See also

locale | set of polymorphic facets that encapsulate cultural differences (class)
use_facet | obtains a facet from a locale (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/locale/has_facet&oldid=91450"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template